# Паттерны проектирования на языке D

Паттерны проектирования по книге [Head First. Паттерны проектирования](https://ftp.zhirov.kz/books/IT/%D0%9F%D0%B0%D1%82%D1%82%D0%B5%D1%80%D0%BD%D1%8B/Head%20First.%20%D0%9F%D0%B0%D1%82%D1%82%D0%B5%D1%80%D0%BD%D1%8B%20%D0%BF%D1%80%D0%BE%D0%B5%D0%BA%D1%82%D0%B8%D1%80%D0%BE%D0%B2%D0%B0%D0%BD%D0%B8%D1%8F%20%28%D0%AD%D1%80%D0%B8%D0%BA%20%D0%A4%D1%80%D0%B8%D0%BC%D0%B5%D0%BD%2C%20%D0%AD%D0%BB%D0%B8%D0%B7%D0%B0%D0%B1%D0%B5%D1%82%20%D0%A0%D0%BE%D0%B1%D1%81%D0%BE%D0%BD%29%202022.pdf) ([исходный код на Java](Head-First-Design-Patterns-master.zip))

## Паттерны

### Поведенческие

1. [Стратегия](strategy/)
2. [Наблюдатель](observer/)
3. [Команда](command/)
4. [Шаблонный метод](templatemethod/)

### Структурные

1. [Декоратор](decorator/)
2. [Адаптер](adapter/)
2. [Фасад](facade/)

### Пораждающие

1. [Фабричный метод (Простая фабрика)](factorymethod/)
2. [Абстрактная фабрика](abstractfactory/)
3. [Одиночка](singleton/)

## Компиляция

```sh
dmd *.d
```

или

```sh
ldc2 *.d
```
